""" Copyright start
  Copyright (C) 2008 - 2025 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end """
from datetime import datetime
import os, sys, signal
from subprocess import check_call
from util.logger import get_logger
from core.listener import Listener

logger = get_logger('__name__')

server = None

pid = None


class FALCONSRVICE:
    @staticmethod
    def shutdown():
        """
        The function is designed to kill this service.
        """
        try:
            if pid:
                os.kill(pid, signal.SIGTERM)
        except Exception as error:
            pass
        check_call(['pkill', '-f', 'falcon.py'])
        exit(0)

    @staticmethod
    def start():
        """
        This function starts the falcon service.
        """
        logger.info("Starting Falcon Service at %s" % str(datetime.now()))
        listener = Listener()
        listener.listen()


def main():
    """
    This is, obviously, the main() function for the CSDASSRV REST service.
    @return:
    """
    rootpath = os.path.join(os.path.dirname(os.path.abspath(__file__)), "../")
    os.chdir(rootpath)
    sys.path.append(os.path.join(os.path.dirname(__file__), "../"))

    error_str = '**** Parameter Required - <start/stop> ****'
    if len(sys.argv) <= 1:
        quit()

    arg = str(sys.argv[1]).lower()
    if arg != 'start' and arg != 'stop':
        quit()

    svc = FALCONSRVICE()
    if arg == 'start':
        svc.start()
    else:
        svc.shutdown()


if __name__ == '__main__':
    main()
